/*
Copyright (C) 2001 CyRUS64 (http://www.boob.co.uk)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

#include "stdafx.h"
#include "IniFile.h"
#include "fstream.h"


///////////////////////////////////////////////
//// Constructors / Deconstructors
///////////////////////////////////////////////

IniFile::IniFile(char *szFileName) {

	sectionstotal = 0;			// STRMNNRM
	bChanged = false;

	if (szFileName == NULL)
		strcpy(m_szFileName, "");
	else 
		strcpy(m_szFileName, szFileName);

}

IniFile::~IniFile()
{
	if (bChanged)
	{
		WriteIniFile(m_szFileName);
	}
}

char * left(char * src, int nchars)
{
	static char dst[300];			// BUGFIX (STRMNNRM)
	strncpy(dst,src,nchars);
	dst[nchars]=0;
	return dst;
}

char * right(char *src, int nchars)
{
	static char dst[300];			// BUGFIX (STRMNNRM)
	strncpy(dst, src + strlen(src) - nchars, nchars);
	dst[nchars]=0;
	return dst;
}

// (STRMNNRMN - Strip spaces from end of names)
char * tidy(char * s)
{
	char * p = s + lstrlen(s);

	p--;
	while (p >= s && *p == ' ')
	{
		*p = 0;
		p--;
	}
	return s;

}

void
IniFile::ReadIniFile()
{
	ifstream inifile;
	char readinfo[100];
	char trim[]="{}"; //remove first and last character
	
	inifile.open(m_szFileName);
	
	if (inifile.fail())
		strcpy(sections[0].crccheck,"Error opening ini file");
	else
	{
		int sectionno=-1;		// STRMNNRMN - sectionno 0 was never being written to
		while (getline(inifile,readinfo)&&sectionno<999)
		{
			tidy(readinfo);			// STRMNNRMN - Strip spaces from end of lines

			if (!_stricmp(readinfo,"")==0)
			{
				if (readinfo[0] == '{') //if a section heading
				{
					StrTrim(readinfo,trim);
					sectionno++;		// STRMNNRM - this will become 0 for the first entry
					strcpy(sections[sectionno].crccheck, readinfo);
					
					strcpy(sections[sectionno].comment, "");
					strcpy(sections[sectionno].comment2, "");
					sections[sectionno].bDisablePatches = false;
					sections[sectionno].bDisableTextureCRC = false;
					sections[sectionno].bDisableEeprom = false;
					sections[sectionno].bIncTexRectEdge = false;
					sections[sectionno].bDisableSpeedSync = false;
					sections[sectionno].bDisableDynarec = false;
					sections[sectionno].nScaleFactor = 1;
					
				}
				else
				{		
					if (_stricmp(left(readinfo,5), "UCode")==0)
						sections[sectionno].ucode=strtol(right(readinfo,1),NULL,10);
					
					if (_stricmp(left(readinfo,7), "Comment")==0)
						strcpy(sections[sectionno].comment,right(readinfo,strlen(readinfo)-8));
					
					if (_stricmp(left(readinfo,4), "Info")==0)
						strcpy(sections[sectionno].comment2,right(readinfo,strlen(readinfo)-5));
					
					if (_stricmp(left(readinfo,4), "Name")==0)
						strcpy(sections[sectionno].name,right(readinfo,strlen(readinfo)-5));
					
					if (_stricmp(left(readinfo,14), "DisableDynarec")==0)
						sections[sectionno].bDisableDynarec=true;
					
					if (_stricmp(left(readinfo,14), "DisablePatches")==0)
						sections[sectionno].bDisablePatches=true;
					
					if (_stricmp(left(readinfo,20), "DisableTextureCRC")==0)
						sections[sectionno].bDisableTextureCRC=true;
					
					if (_stricmp(left(readinfo,13), "DisableEeprom")==0)
						sections[sectionno].bDisableEeprom=true;
					
					if (_stricmp(left(readinfo,16), "DisableSpeedSync")==0)
						sections[sectionno].bDisableSpeedSync=true;
					
					if (_stricmp(left(readinfo,14), "IncTexRectEdge")==0)
						sections[sectionno].bIncTexRectEdge=true;

					if (_stricmp(left(readinfo,11), "ScaleFactor")==0)
						sections[sectionno].nScaleFactor = strtol(right(readinfo,1),NULL,10);
					
				}
			}
		}
		sectionstotal=sectionno+1;	//(STRMNNRMN - This was -1, but because of -1 setting above, it needs to be +1)
		inifile.close();
	}


}

//read a line from the ini file
istream & IniFile::getline(istream & is, char *str)
{
    char buf[100];
	
    is.getline(buf,100);
    strcpy( str,buf);
    return is;
}

void IniFile::WriteIniFile(LPCTSTR szFileName)
{
	LONG i;
	FILE * fh;

	fh = fopen(szFileName, "w");
	if (fh == NULL)
		return;

	for (i = 0; i < sectionstotal; i++)
	{
		fprintf(fh, "\n");			// Spacer
		fprintf(fh, "{%s}\n", sections[i].crccheck);
		
		fprintf(fh, "Name=%s\n", sections[i].name);
		fprintf(fh, "UCode=%d\n", sections[i].ucode);

		if (lstrlen(sections[i].comment) > 0)
			fprintf(fh, "Comment=%s\n", sections[i].comment);

		if (lstrlen(sections[i].comment2) > 0)
			fprintf(fh, "Info=%s\n", sections[i].comment2);

		if (sections[i].bDisableDynarec)
			fprintf(fh, "DisableDynarec\n");

		if (sections[i].bDisablePatches)
			fprintf(fh, "DisablePatches\n");

		if (sections[i].bDisableTextureCRC)
			fprintf(fh, "DisableTextureCRC\n");

		if (sections[i].bDisableEeprom)
			fprintf(fh, "DisableEeprom\n");

		if (sections[i].bDisableSpeedSync)
			fprintf(fh, "DisableSpeedSync\n");

		if (sections[i].bIncTexRectEdge)
			fprintf(fh, "IncTexRectEdge\n");

		if (sections[i].nScaleFactor != 1)
			fprintf(fh, "ScaleFactor=%d\n", sections[i].nScaleFactor);
	}
	fclose(fh);

	bChanged = false;
}




// Find the entry corresponding to the specified rom. 
// If the rom is not found, a new entry is created
// The resulting value is returned
int IniFile::FindEntry(DWORD dwCRC1, DWORD dwCRC2, BYTE nCountryID, LPCTSTR szName)
{
	LONG i;
	CHAR szCRC[50+1];
	
	// Generate the CRC-ID for this rom:
	wsprintf(szCRC, "%08x%08x-%02x", dwCRC1, dwCRC2, nCountryID);

	for (i = 0; i < sectionstotal; i++)
	{
		if (lstrcmpi(szCRC, sections[i].crccheck) == 0)
			return i;
	}
	
	// Add new entry!!!
	strcpy(sections[sectionstotal].crccheck, szCRC);
	
	lstrcpyn(sections[sectionstotal].name, szName, 50);
	sections[sectionstotal].ucode = 0;
	strcpy(sections[sectionstotal].comment, "");
	strcpy(sections[sectionstotal].comment2, "");
	sections[sectionstotal].bDisablePatches = false;
	sections[sectionstotal].bDisableTextureCRC = false;
	sections[sectionstotal].bDisableEeprom = false;
	sections[sectionstotal].bIncTexRectEdge = false;
	sections[sectionstotal].bDisableSpeedSync = false;
	sections[sectionstotal].bDisableDynarec = false;
	sectionstotal++;

	bChanged = true;				// Flag to indicate we should be updated
	return sectionstotal-1;			// -1 takes into account increment
		
}