/*
Copyright (C) 2001 StrmnNrmn

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/




static DWORD InternalWriteInvalid(DWORD dwAddress, void ** pTranslated)
{
	//CPUHalt();
	//DBGConsole_Msg(0, "Illegal Write at 0x%08x", dwAddress);
	//DPF(DEBUG_MEMWARN, "Illegal Memory Access Tried to Write To 0x%08x PC: 0x%08x", dwAddress, g_dwPC);

	*pTranslated = MemoryBuffers[MEM_UNUSED];

	return MEM_UNUSED;
}



static DWORD InternalWriteMappedGolden(DWORD dwAddress, void ** pTranslated)
{
	DWORD dwTranslated = (dwAddress- 0x7f000000) + GOLDENEYE_HACKED_OFFSET;
	//DWORD dwTranslated = dwAddress + dwGEOff;
	DBGConsole_Msg(0, "Writing Golden Mapped from 0x%08x, 0x%08x", dwAddress, dwTranslated);
	//return MemoryBuffers[MEM_UNUSED];

	*pTranslated = (BYTE *)MemoryBuffers[MEM_CARTROM] + (dwTranslated & 0x00FFFFFF);
	return MEM_CARTROM;
}




static DWORD InternalWriteMapped(DWORD dwAddress, void ** pTranslated)
{

	for (DWORD dwI = 0; dwI < 32; dwI++) {
		struct TLBEntry & tlb = g_TLBs[dwI];

		if ((dwAddress & ~tlb.mask) != (tlb.vpn2 & ~tlb.mask))
			continue;
		
		// Matched entry
		if (tlb.g)
		{
			// Global
			if (dwAddress & tlb.checkbit)
			{
				// Odd entry
				if (tlb.pfno & TLBLO_V)
				{
					// Valid
					DWORD dwAddr = 0x80000000 |
							       ((tlb.pfno<<6) & ((~tlb.mask)>>1)) |
								   (dwAddress & (tlb.mask>>1));

					//DPF(DEBUG_TLB, "TLB Mapping: Write: 0x%08x -> 0x%08x", dwAddress, dwAddr);
					return InternalWriteAddress(dwAddr, pTranslated);
				}
				else
				{
					// Throw TLB Invalid exception
					DBGConsole_Msg(DEBUG_TLB, "InternalWM: TLB: Invalid Write");
					//DPF(DEBUG_TLB, "Write: TLB Invalid Exception: 0x%08x", dwAddress);
					return InternalWriteInvalid(dwAddress, pTranslated);
				}
			} else {
				// Even entry 
				if (tlb.pfne & TLBLO_V) {
					// Valid
					DWORD dwAddr = 0x80000000 |
							       ((tlb.pfne<<6) & ((~tlb.mask)>>1)) |
								   (dwAddress & (tlb.mask>>1));

					//DPF(DEBUG_TLB, "InternalWM: TLB Mapping: Write: 0x%08x -> 0x%08x", dwAddress, dwAddr);
					return InternalWriteAddress(dwAddr, pTranslated);
				} else {
					// Throw TLB Invalid exception
					DBGConsole_Msg(DEBUG_TLB, "InternalWM: TLB: Invalid Write");
					//DPF(DEBUG_TLB, "InternalWM: TLB Invalid Exception: 0x%08x", dwAddress);
					return InternalWriteInvalid(dwAddress, pTranslated);
				}
			}
		} else {
			// Not Global
			// Do ASID stuff
			DBGConsole_Msg(DEBUG_TLB, "InternalWM: TLB: ASID Write (NoImpl)");
			return InternalWriteInvalid(dwAddress, pTranslated);
		}
	}

	return InternalWriteInvalid(dwAddress, pTranslated);
}



static DWORD InternalWrite_4Mb_8000_803F(DWORD dwAddress, void ** pTranslated)
{
	*pTranslated = g_pu8RamBase + (dwAddress & 0x003FFFFF);
	return MEM_RD_RAM;
}

static DWORD InternalWrite_8Mb_8000_807F(DWORD dwAddress, void ** pTranslated)
{
	*pTranslated = g_pu8RamBase + (dwAddress & 0x007FFFFF);
	return MEM_RD_RAM;
}


